/*
 * graphics.c
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

/*
 *
 */

#include	"graphics.h"

/*
 *	Q[ʂ͍_ W_W_SIZE*W_W_SIZE ̋`̍Wnōl
 */

#define	SCALE		200

#define	W_W_SIZE	(2*SCALE)	/* Window ̉ (200) */
#define	W_H_SIZE	(2*SCALE)	/* Window ̏c (200) */

/*
 *	Q[̍W (0,0)-(X,Y) AOpenGL ̍W (-1,-1)-(1,1) ւ̕ϊ
 */

#define	rSize(R)	((double)(R)/SCALE)
#define	xPos(X)		rSize(X-SCALE)
#define	yPos(Y)		rSize(Y-SCALE)

/*
 *	ubN̏
 */

#define	B_W_COUNT	10		/* ubN̉̌ */
#define	B_H_COUNT	5		/* ubNš */

#define	B_W_SIZE	( W_W_SIZE   /B_W_COUNT)	/* ubN̉ */
#define	B_H_SIZE	((W_H_SIZE/4)/B_H_COUNT)	/* ubNs */

#define	B_W_PITCH	(B_W_SIZE/10)				/* ubN̉̌ */
#define	B_H_PITCH	(B_H_SIZE/10)				/* ubNš */

#define	B_W_BASE	0
#define	B_H_BASE	(W_H_SIZE*3/4)				/* ubN̔zu͏ 1/4 */

#define	bxPos(BX)		(B_W_BASE+B_W_SIZE/2+(BX)*B_W_SIZE)
#define	byPos(BY)		(B_H_BASE+B_H_SIZE/2+(BY)*B_H_SIZE)

#define	BLOCK_ON	1
#define	BLOCK_OFF	0

static char block[B_W_COUNT][B_H_COUNT];	/* ubN̏ */
static int bolockCount;						/* c̃ubN */

/*
 *	ph̏
 */

#define	PADDLE_W_SIZE	B_W_SIZE
#define	PADDLE_H_SIZE	B_H_SIZE

#define	PADDLE_DX	(B_W_SIZE/10)

static int paddleSpeed = PADDLE_DX;				/* pḧړx */
static int paddleLength = PADDLE_W_SIZE;		/* ph̒ */
static int paddleX = W_W_SIZE/2;				/* ph X W */

/*
 *	{[̏
 */

#define	BALL_R	(B_H_SIZE/4)

static int ballX = W_W_SIZE/2;					/* {[ x W */
static int ballY = W_H_SIZE/2;					/* {[ y W */
static int ballVX = 1;							/* {[ x x */
static int ballVY = 1;							/* {[ y x */

#define	BALL_SPEED_SCALE	10000

static int ballWait = BALL_SPEED_SCALE;			/* {[ړ܂ł̑Ҏ */
static int ballTime = 0;						/* {[ */

/*
 *	_
 */

static int point = 0;							/* _ */

/*
 * (JvZ)
 */

int cupcelExists = 0;	/* ݃JvZ͂Ȃ */
int cupcelX;			/* JvZ X W */
int cupcelY;			/* JvZ Y W */

/*
 *	Q[WŁAhׂ̋`
 */

static	void	fillRect( int x1, int y1, int x2, int y2 ) {
  double	gx1 = xPos(x1);
  double	gy1 = yPos(y1);
  double	gx2 = xPos(x2);
  double	gy2 = yPos(y2);

  glBegin(GL_QUADS);
  glVertex2d(gx1,gy1);
  glVertex2d(gx1,gy2);
  glVertex2d(gx2,gy2);
  glVertex2d(gx2,gy1);
  glEnd();
}

/*
 *	Q[WŁAhׂ̉~
 */

#define PART 100 // 
 
static void fillCircle( int x, int y, int r ) {
  int i;
  int n = PART;
  double gcx = xPos(x);
  double gcy = yPos(y);
  double gr = rSize(r);

  glBegin(GL_POLYGON); // |S̕`

  // ~`
  for (i = 0; i < n; i++) {
    // WvZ
	double rate= (double)i / n;
	double px = gr * cos(2.0 * M_PI * rate) + gcx;
	double py = gr * sin(2.0 * M_PI * rate) + gcy;

    glVertex2d(px, py); // _Ww
  }

  glEnd(); // |S̕`I

}

/*
 *	w肵ꏊ𒆐SƂubN\
 */

static void drawBlock( int px, int py, int bw, int bh ) {

  fillRect (
			px - (bw-B_W_PITCH)/2,
			py - (bh-B_H_PITCH)/2,
			px + (bw-B_W_PITCH)/2,
			py + (bh-B_H_PITCH)/2 );
}

/*
 * OpenGL ŁAEBhE̕\Kv
 * ꍇɍĕ\s֐
 */

static void display(void)
{
  int bx;
  int by;

  glClearColor(0.0, 0.4, 0.0, 0.0);	/*  */
  glClear(GL_COLOR_BUFFER_BIT);		/* EBhE̒hׂ */

  glColor3f(1.0, 1.0, 1.0); /* `敨̂ɔFݒ */

  /* ubN̕\ */
  for ( by = 0; by < B_H_COUNT; by++ ) {
	for ( bx = 0; bx < B_W_COUNT; bx++ ) {
	  if ( block[bx][by] == BLOCK_ON ) {
		drawBlock ( bxPos(bx), byPos(by), B_W_SIZE, B_H_SIZE );
	  }
	}
  }

  /* ph̕\ */
  drawBlock ( paddleX, PADDLE_H_SIZE / 2, paddleLength, PADDLE_H_SIZE );

  /* {[̕\ */
  fillCircle( ballX, ballY, BALL_R );

  /* JvZ̕\ */

  glColor3f(0.4, 0.0, 0.0); /* JvZ̐F͐ */

	if ( cupcelExists == 1 ) {
		fillCircle( cupcelX, cupcelY, BALL_R );
	}

  glFlush();  /* \̏I */

}

/*
 *	ubN̐ݒu
 */

static void blockInit() {
  int bx;
  int by;

  /* ׂẴubNɑ΂ */

  for ( by = 0; by < B_H_COUNT; by++ ) {
	for ( bx = 0; bx < B_W_COUNT; bx++ ) {
	  block[bx][by] = BLOCK_ON;	/* ubN On ɂ */
	}
  }

  bolockCount = B_H_COUNT * B_W_COUNT;

}

/*
 *	s
 */

static void init(void)
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_FLAT);

	blockInit();

	cupcelExists = 0;
	cupcelX = 100;
	cupcelY = 100;

}

/*
 *	phw肵ʒuɈړB
 *	Aړ悪ÄȌꍇ́ÄɂȂ悤ɒĈړB
 */

static	void	move_paddle ( int x ) {

  if ( x <= paddleLength/2 ) {					/* ߂ */
	x = paddleLength/2+1;							/* 肬ɂ */
  } else if ( x >= W_W_SIZE - paddleLength/2 ) {	/* E߂ */
	x = W_W_SIZE - paddleLength/2 - 1;			/* E肬ɂ */
  }

  paddleX = x;									/* phړ */
}

/*
 *	{^ƌĂ΂֐
 */

static void mouse(int button, int state, int x, int y)
{

	switch (button) {
	case GLUT_LEFT_BUTTON:				/* {^ꂽ */
	  if ( state == GLUT_DOWN ) {		/* vbV */
		move_paddle ( x );				/* }EẌʒuɃphړ */
		display();						/* \̍XV */
	  }
	  break;
	case GLUT_MIDDLE_BUTTON:
	  break;
	case GLUT_RIGHT_BUTTON:
	  break;
	default:
	  break;
	}
}

/*
 *	Փˏ ( {[w肵ubNɂԂĂȂA̕Ԃ )
 */

#define	collisionDirect(signX,signY)	((signY+1)*4+(signX+1))
#define	collisionX(dir)					((dir)%4-1)
#define	collisionY(dir)					((dir)/4-1)

#define	COLLISION_NONE			(-1)
#define	COLLISION_CENTER		collisionDirect(0,0)
#define	COLLISION_UP			collisionDirect(1,0)
#define	COLLISION_UP_RIGHT		collisionDirect(1,1)
#define	COLLISION_RIGHT			collisionDirect(0,1)
#define	COLLISION_DOWN_RIGHT	collisionDirect(-1,1)
#define	COLLISION_DOWN			collisionDirect(-1,0)
#define	COLLISION_DOWN_LEFT		collisionDirect(-1,-1)
#define	COLLISION_LEFT			collisionDirect(0,-1)
#define	COLLISION_UP_LEFT	7	collisionDirect(1,-1)

int	collisionBlock ( int bx, int by, int bw, int bh ) {

  if ( abs( ballY - by ) < (bh/2) + BALL_R && abs(ballX - bx) < (bw/2) + BALL_R ) {
	/* ԂĂ */

	int signX = 0;
	int signY = 0;

	if ( ballX < bx - (bw/2) ) {			/*  */
	  signX = - 1;							/* ԂĂ */
	} else if ( ballX > bx + (bw/2) ) {
	  signX = 1;							/* EԂĂ */
	}

	if ( ballY < by - (bh/2) ) {			/* s */
	  signY = - 1;							/* ԂĂ */
	} else if ( ballY > by + (bh/2) ) {
	  signY = 1;							/* ォԂĂ */
	}

	return collisionDirect(signX,signY);	/* sƉ̍ */
  }

  return COLLISION_NONE;					/* ԂĂȂꍇ */
} 

/*
 *	̑̏ꍇɁAPIɉxĂяo
 */

static	void	idle(void) {

  /*
   * idle ͉΂̂ŁA{[Ƒ߂
   * idle Ăяo񐔂 ballTime ŋL^Aꂪ ballWait 
   * {[𓮂
   */

  if ( ballTime++ > ballWait ) {	/* {[̑ҎԂ */
	ballTime = 0;					/* ^C}[Zbg */

	if ( ballVX > 0 ) {
		  /* E̕ǂւ̏Փˏ */
	  if ( ballX + ballVX < W_H_SIZE - BALL_R ) {
		ballX = ballX + ballVX;
	  } else {	/* E̕ǂւ̏Փ˂̂ŁAς */
		ballVX = - ballVX;
	  }
	} else if ( ballVX < 0 ) {
		  /* ̕ǂւ̏Փˏ */
	  if ( ballX + ballVX > BALL_R ) {
		ballX = ballX + ballVX;
	  } else {	/* ̕ǂւ̏Փ˂̂ŁAς */
		ballVX = - ballVX;
	  }
	}

	if ( ballVY > 0 ) {			/* Ɉړ */
		  /* ̕ǂւ̏Փˏ */
	  if ( ballY + ballVY < W_W_SIZE - BALL_R ) {
		ballY = ballY + ballVY;
	  } else {	/* ̕ǂւ̏Փ˂̂ŁAς */
		ballVY = - ballVY;
	  }
	} else if ( ballVY < 0 ) {		/* Ɉړ */
		  /* ̕ǂւ̏Փˏ */
	  if ( ballY + ballVY > BALL_R ) {
		ballY = ballY + ballVY;
	  } else {	/* Q[I[o */
		printf ( "point = %d\n", point );	/* |Cgo͂ */
		exit(0);							/* I */
	  }
	}

	/* phƂ̏Փˏ */
	if ( ballVY < 0 && collisionBlock(
						  paddleX, PADDLE_H_SIZE / 2,
						  paddleLength, PADDLE_H_SIZE ) >= 0 ) {

	  ballVY = - ballVY;
	  /* ph̏ꍇ́AꏊƖ֌WɁAɒe */

	}

	/* ubNƂ̏Փˏ */
	{
	  int bx;
	  int by;

	  for ( by = 0; by < B_H_COUNT; by++ ) {
		for ( bx = 0; bx < B_W_COUNT; bx++ ) {
		  if ( block[bx][by] == BLOCK_ON ) {
			/* ubN */

			int dir = collisionBlock( bxPos(bx), byPos(by), B_W_SIZE, B_H_SIZE );

			if ( dir >= 0 ) {				/* Փ˂ */

			  point = point + 1;			/* _ӂ₷ */
			  block[bx][by] = BLOCK_OFF;	/* ubN */
			  bolockCount = bolockCount - 1;
			  /* cubN炷 */

			  if ( cupcelExists == 0 ) { /* JvZȂ */
				cupcelExists = 1;
				cupcelX = bxPos(bx);
				cupcelY = byPos(by);
			  }

			  switch ( collisionX(dir) ) {
			  case 1:				/* EɂԂ */
				if ( ballVX < 0 ) {	/* E痈ȂAɂ */
				  ballVX = - ballVX;
				}
				break;
			  case -1:				/* ɂԂ */
				if ( ballVX > 0 ) {	/* 痈ȂAEɂ */
				  ballVX = - ballVX;
				}
				break;
			  }

			  switch ( collisionY(dir) ) {
			  case 1:				/* ɂԂ */
				if ( ballVY < 0 ) {	/* ォ痈ȂAɂ */
				  ballVY = - ballVY;
				}
				break;
			  case -1:				/* ɂԂ */
				if ( ballVY > 0 ) {	/* 痈ȂAɂ */
				  ballVY = - ballVY;
				}
				break;
			  }
			}
		  }
		}
	  }

	  if ( cupcelExists == 1 ) {	/* JvZ */
		cupcelY = cupcelY - 2; 	/* ɗ */
		if ( cupcelY <= 0 ) {		/* ̕ǂ܂ł */
		  cupcelExists = 0;		/* JvZ͏ */
		}

		if ( cupcelY < PADDLE_H_SIZE ) {
		  /* ԉ܂ł */

		  //	printf ( "%d, %d, %d\n",
		  //		   cupcelX,
		  //		   cupcelY,
		  //		   paddleX ); /* foOvg */

		  if ( paddleX - PADDLE_W_SIZE / 2 < cupcelX &&
			   cupcelX < paddleX + PADDLE_W_SIZE / 2 ) {
			/* phɂԂ */
			cupcelExists = 0;		/* JvZ͏ */
			paddleLength = paddleLength + 10;
			/* {[iXƂăph̕傫 */
		  }
		}
	  }
	}

	display();
  }

  /* ubNȂȂ .. */
  if ( bolockCount <= 0 ) {
	if ( ballY < B_H_BASE - BALL_R ) {
	  /* {[ubN̗̈悩o_.. */
	  blockInit();	/* ubN𕜊 */
	  display();
	}
  }
}

/*
 *	L[{[h̃L[ƌĂ΂֐
 * 	L[{[hɉ΁AύX
 */

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':  /* '\033'  ESC  ASCII R[h */
    exit(0);
	/* L[{[h 'q'/'Q'/ESC L[ƏI */

  case ',':
	/* ph ( Ɉړ ) */
	if ( paddleX > paddleLength/2 + paddleSpeed ) {	/* ړ\Ȃ.. */
	  paddleX = paddleX - paddleSpeed;				/* ̕Ɉړ */
	  display();
	}
    break;

  case '.':
	/* ph ( EɈړ ) */
	if ( paddleX < W_W_SIZE - paddleLength/2 - paddleSpeed ) {
	  paddleX = paddleX + paddleSpeed;
	  display();
	}
    break;

  case '+':
	/* ph̒𒷂 */
	if ( paddleLength < W_W_SIZE ) {
	  paddleLength = paddleLength + 10;
	  move_paddle ( paddleX );
	  display();
	}
    break;

  case '-':
	/* ph̒Z */
	if ( paddleLength > PADDLE_W_SIZE ) {
	  paddleLength = paddleLength - 10;
	  move_paddle ( paddleX );
	  display();
	}
    break;

  case '*':
	/* pḧړx𑬂 */
	if ( paddleSpeed < paddleLength ) {
	  paddleSpeed = paddleSpeed + PADDLE_DX;
	}
    break;

  case '/':
	/* pḧړxx */
	if ( paddleSpeed > PADDLE_DX ) {
	  paddleSpeed = paddleSpeed - PADDLE_DX;
	}
    break;

  case '<':
	/* {[̈ړx𑬂 */
	if ( ballWait > 1 ) {
	  ballWait = ballWait / 2;
	}
    break;

  case '>':
	/* {[̈ړxx */
	  ballWait = ballWait * 2;
    break;

  default:
    break;
  }
}

/*
 *	GL ̏֐
 */

void graphics_init ( int argc, char** argv )
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA);
//	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(W_W_SIZE,W_H_SIZE);
	/* Window ̃TCY */
	glutInitWindowPosition(100, 100);
	glutCreateWindow(argv[0]);
	init();

	glutDisplayFunc(display);
	/* ŁAKvɉāAʂ̂Ȃ
	   s֐ (display) w肵Ă */
	glutMouseFunc(mouse);
	/* ŁA}EXNbNꂽ̏
	   s֐(mouse)w肵Ă */
	glutKeyboardFunc(keyboard);
	/* ŁAL[{[hꂽ̏
	   s֐(keyboard)w肵Ă */
	glutIdleFunc(idle);
	/* ŁA͂ĂȂ̏
	   s֐(idle)w肵Ă
	   Aj[VȂǎIɁAԂ
	   XV鏈 idle ɂ点
	*/

	/* ̏ */
	while ( argc > 1 ) {
	  if ( !strcmp ( argv[1], "-b" ) ) {	/* {[̑҂̑傫 */
		ballWait = atoi ( argv[2] );
		if ( ballWait <= 0 ) {
		  ballWait = BALL_SPEED_SCALE;
		}
		argc = argc - 2; 
		argv = argv + 2; 
	  } else if ( !strcmp ( argv[1], "-p" ) ) {	/* pḧړx */
		paddleSpeed = atoi ( argv[2] );
		if ( paddleSpeed <= 0 ) {
		  paddleSpeed = PADDLE_DX;
		}
		argc = argc - 2; 
		argv = argv + 2; 
	  } else {
		break;
	  }
	}

	glutMainLoop();
	/* `Jn */
}

/*
 *
 */

